sms.uthg        equ     $28
sms.fthg        equ     $29
sms.info        equ     $00
sys_thgl        equ     $b8
th_thing        equ     $10
th_name         equ     $2a
thh_type        equ     $04
thh_entr        equ     $08
err.nimp        equ     -19

.text
.globl  _CSFree
.globl  _CSUse

_CSFree:
        movem.l  a2-a6/d2-d7,-(sp)
        bsr     getthg
        bne     cs0
        bsr     Setup
        moveq   #sms.fthg,d0
	jsr     (a5)
cs0:
        movem.l  (sp)+,a2-a6/d2-d7
        rts
Setup:
        move.l  a0,a5
        move.l  48+4(sp),d2
        move.l  52+4(sp),d3
        lea.l   thgname,a0
	moveq   #-1,d1
        rts

_CSUse:
        movem.l  a2-a6/d2-d7,-(sp)
        bsr     getthg
        bne     cs0
        bsr     Setup
        moveq   #sms.uthg,d0
	jsr     (a5)
	tst.l	d0
	bne	cs0
        jsr     $18(a1)
        move.l  56(sp),a1
        move.l  d2,(a1)
	bra	cs0

getthg:
        moveq   #sms.info,d0            ; get system variables
        trap    #1
        move.l  sys_thgl(a0),d2         ; this is the thing list
        beq     thg_nf                  ; empty list, very bad!
        move.l  d2,a0
thg_lp:
        move.l  (a0),d2                 ; get next list entry
        beq     thg_found               ; end of list? here should be thing!
        move.l  d2,a0                   ; next link
        bra     thg_lp
thg_found:
        move.l  th_thing(a0),a0         ; get start of thing
        move.l  thh_type(a0),d2         ; is it our special thing?
        addq.l  #1,d2
        bne     thg_nf                  ; sorry, it isnt
        move.l  thh_entr(a0),a0         ; this is the vector we look for
        bra     thg_rts
thg_nf:
        moveq   #err.nimp,d0            ; no thing
thg_rts:
        tst.l   d0
        rts

thgname:
        dc.w    13
        dc.b    'Client Server',0
        end
